{-# LANGUAGE NoImplicitPrelude #-}
module Bamboo.Type.Theme where

import Bamboo.Helper.PreludeEnv
import Data.Default



data Theme = Theme
  { name        :: String
  , container   :: String
  , header      :: String
  , navigation  :: String
  , main        :: String
  , sidebar     :: String
  , footer      :: String
  , css         :: [String]
  , js          :: [String]
  } deriving (Show, Read)

data ThemeData = 
    Name
  | Container
  | Header
  | Navigation
  | Main
  | Sidebar
  | Footer
  | Css
  | Js
  deriving (Eq, Show, Read)

instance Default Theme where
  def = Theme def def def def def def def def def