{-# LANGUAGE NoImplicitPrelude #-}
module Bamboo.View.Widget.Footer where
  
import Bamboo.View.Env

import qualified Bamboo.Type.Config as C
import qualified Bamboo.Type.Theme as T


footer :: Widget
footer s = div_class_id (s.config.theme.T.footer) "footer" << custom_footer
  where
    static_footer = toHtml
      [ toHtml $ copyright
      , toHtml $ "2008 "
      , toHtml $ s.config.blog_title
      , toHtml $ br
      , toHtml $ "Powered by "
      , toHtml $ hotlink (s.config.bamboo_url) << "Bamboo"
      , toHtml $ " using "
      , toHtml $ hotlink "http://www.haskell.org/" << "Haskell"
      ]

    custom_footer
      | s.config.C.footer.isJust = s.config.C.footer.fromJust.markup
      | otherwise = static_footer
