{-# LANGUAGE NoImplicitPrelude #-}
module Bamboo.View.Widget.Head where

import Bamboo.Type.Theme (css, js)
import Bamboo.View.Env
import Bamboo.View.Widget.Helper
import qualified Bamboo.Type as C
import qualified Bamboo.Type.State as S


html_head :: Widget
html_head s = header << (
  [ meta_tag, title_tag
  , favicon_tag
  , rss_tag
  ] 
  ++ s.config.theme.css.map css_link
  ++ s.config.theme.js.map js_link
  )
  
  where
    title_tag = thetitle << 
      [s.config.blog_title ++ s.S.resource_title.format_title]

    rss_tag = rss_link $ rss_url_link_pair s .fst
    favicon_tag = favicon_link $ s.config.favicon

    format_title [] = ""
    format_title x = " / " ++ x