{-# LANGUAGE NoImplicitPrelude #-}
module Bamboo.View.Widget.Header where
  
import Bamboo.View.Env hiding (header)
import Bamboo.View.Widget.SearchBar (search_bar)
import qualified Bamboo.Type.Theme as T

header :: Widget
header s =
  div_class_id (s.config.theme.T.header) "header" << 
    [ search_bar s
    , site_name s
    ]

site_name :: Widget
site_name s = toHtml $
  [ toHtml $ hotlink (s.config.root) ! [theclass "logo"] << ""
  , h1 << s.config.blog_title
  , div_class "description" << s.config.blog_subtitle
  ]
