{-# LANGUAGE NoImplicitPrelude #-}
module Bamboo.View.Widget.Helper where

import Bamboo.View.Env hiding (link)
  
import qualified Bamboo.Type as C
import Bamboo.Type (tag_id, root)
import qualified Bamboo.Type.State as State
import qualified Bamboo.Model.Tag as Tag

rss_url_link_pair :: State.State -> (String, HotLink)
rss_url_link_pair s = 
  if tagged 
  then
    let tag_name = Tag.get_name uid in
      link ( s.config.tag_id / tag_name) tag_name
  else link "" home_nav
  where
    uid = State.uid s
    tagged = uid.match "^tag/.+" .isJust
    url r = s.config.root / r / "rss.xml"
    link r x = (url r, hotlink (url r) ! [ theclass "feedlink" ] << x)